#ifndef PROXY_H
#define PROXY_H


#include <stdarg.h>

#include <tcp++/tcp_client.h>
#include <tcp++/tcp_server.h>

class Proxy : public TcpServer
 {
  protected:
      char* spoof_user_agent;

      void handle_client(int client_socket_fd);
      void parse_request(char *request, char* method, char* host, int& port, char* file,
       char* protocol);

      void process_get(FILE* in, FILE* out, TcpClient* http_client);
      void process_post(FILE* in, FILE* out, TcpClient* http_client);
      void fix_user_agent(char* relay_buf);

  public:

   Proxy(int port, int listen_queue_size, char* log_file) : 
     TcpServer(port, listen_queue_size, log_file)
    {
     spoof_user_agent = NULL;
    }
   void set_spoof_user_agent(char* init_spoof_user_agent)
    {
     spoof_user_agent = init_spoof_user_agent;
    }

  #ifdef DEBUG
   friend int main(int c, char** args);
  #endif
 };

#endif
